# This file was auto-generated by Fern from our API Definition.

import typing
from ..core.client_wrapper import SyncClientWrapper
from .raw_client import RawAssistantsClient
import datetime as dt
from ..core.request_options import RequestOptions
from ..types.assistant import Assistant
from ..types.create_assistant_dto_transcriber import CreateAssistantDtoTranscriber
from ..types.create_assistant_dto_model import CreateAssistantDtoModel
from ..types.create_assistant_dto_voice import CreateAssistantDtoVoice
from ..types.create_assistant_dto_first_message_mode import CreateAssistantDtoFirstMessageMode
from ..types.create_assistant_dto_voicemail_detection import CreateAssistantDtoVoicemailDetection
from ..types.create_assistant_dto_client_messages_item import CreateAssistantDtoClientMessagesItem
from ..types.create_assistant_dto_server_messages_item import CreateAssistantDtoServerMessagesItem
from ..types.create_assistant_dto_background_sound import CreateAssistantDtoBackgroundSound
from ..types.transport_configuration_twilio import TransportConfigurationTwilio
from ..types.langfuse_observability_plan import LangfuseObservabilityPlan
from ..types.create_assistant_dto_credentials_item import CreateAssistantDtoCredentialsItem
from ..types.compliance_plan import CompliancePlan
from ..types.analysis_plan import AnalysisPlan
from ..types.artifact_plan import ArtifactPlan
from ..types.message_plan import MessagePlan
from ..types.start_speaking_plan import StartSpeakingPlan
from ..types.stop_speaking_plan import StopSpeakingPlan
from ..types.monitor_plan import MonitorPlan
from ..types.server import Server
from ..types.assistant_hooks import AssistantHooks
from ..types.keypad_input_plan import KeypadInputPlan
from .types.update_assistant_dto_transcriber import UpdateAssistantDtoTranscriber
from .types.update_assistant_dto_model import UpdateAssistantDtoModel
from .types.update_assistant_dto_voice import UpdateAssistantDtoVoice
from .types.update_assistant_dto_first_message_mode import UpdateAssistantDtoFirstMessageMode
from .types.update_assistant_dto_voicemail_detection import UpdateAssistantDtoVoicemailDetection
from .types.update_assistant_dto_client_messages_item import UpdateAssistantDtoClientMessagesItem
from .types.update_assistant_dto_server_messages_item import UpdateAssistantDtoServerMessagesItem
from .types.update_assistant_dto_background_sound import UpdateAssistantDtoBackgroundSound
from .types.update_assistant_dto_credentials_item import UpdateAssistantDtoCredentialsItem
from ..core.client_wrapper import AsyncClientWrapper
from .raw_client import AsyncRawAssistantsClient

# this is used as the default value for optional parameters
OMIT = typing.cast(typing.Any, ...)


class AssistantsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawAssistantsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawAssistantsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawAssistantsClient
        """
        return self._raw_client

    def list(
        self,
        *,
        limit: typing.Optional[float] = None,
        created_at_gt: typing.Optional[dt.datetime] = None,
        created_at_lt: typing.Optional[dt.datetime] = None,
        created_at_ge: typing.Optional[dt.datetime] = None,
        created_at_le: typing.Optional[dt.datetime] = None,
        updated_at_gt: typing.Optional[dt.datetime] = None,
        updated_at_lt: typing.Optional[dt.datetime] = None,
        updated_at_ge: typing.Optional[dt.datetime] = None,
        updated_at_le: typing.Optional[dt.datetime] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> typing.List[Assistant]:
        """
        Parameters
        ----------
        limit : typing.Optional[float]
            This is the maximum number of items to return. Defaults to 100.

        created_at_gt : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than the specified value.

        created_at_lt : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than the specified value.

        created_at_ge : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than or equal to the specified value.

        created_at_le : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than or equal to the specified value.

        updated_at_gt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than the specified value.

        updated_at_lt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than the specified value.

        updated_at_ge : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than or equal to the specified value.

        updated_at_le : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than or equal to the specified value.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        typing.List[Assistant]

        """
        response = self._raw_client.list(
            limit=limit,
            created_at_gt=created_at_gt,
            created_at_lt=created_at_lt,
            created_at_ge=created_at_ge,
            created_at_le=created_at_le,
            updated_at_gt=updated_at_gt,
            updated_at_lt=updated_at_lt,
            updated_at_ge=updated_at_ge,
            updated_at_le=updated_at_le,
            request_options=request_options,
        )
        return response.data

    def create(
        self,
        *,
        transcriber: typing.Optional[CreateAssistantDtoTranscriber] = OMIT,
        model: typing.Optional[CreateAssistantDtoModel] = OMIT,
        voice: typing.Optional[CreateAssistantDtoVoice] = OMIT,
        first_message: typing.Optional[str] = OMIT,
        first_message_interruptions_enabled: typing.Optional[bool] = OMIT,
        first_message_mode: typing.Optional[CreateAssistantDtoFirstMessageMode] = OMIT,
        voicemail_detection: typing.Optional[CreateAssistantDtoVoicemailDetection] = OMIT,
        client_messages: typing.Optional[typing.Sequence[CreateAssistantDtoClientMessagesItem]] = OMIT,
        server_messages: typing.Optional[typing.Sequence[CreateAssistantDtoServerMessagesItem]] = OMIT,
        silence_timeout_seconds: typing.Optional[float] = OMIT,
        max_duration_seconds: typing.Optional[float] = OMIT,
        background_sound: typing.Optional[CreateAssistantDtoBackgroundSound] = OMIT,
        background_denoising_enabled: typing.Optional[bool] = OMIT,
        model_output_in_messages_enabled: typing.Optional[bool] = OMIT,
        transport_configurations: typing.Optional[typing.Sequence[TransportConfigurationTwilio]] = OMIT,
        observability_plan: typing.Optional[LangfuseObservabilityPlan] = OMIT,
        credentials: typing.Optional[typing.Sequence[CreateAssistantDtoCredentialsItem]] = OMIT,
        name: typing.Optional[str] = OMIT,
        voicemail_message: typing.Optional[str] = OMIT,
        end_call_message: typing.Optional[str] = OMIT,
        end_call_phrases: typing.Optional[typing.Sequence[str]] = OMIT,
        compliance_plan: typing.Optional[CompliancePlan] = OMIT,
        metadata: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = OMIT,
        analysis_plan: typing.Optional[AnalysisPlan] = OMIT,
        artifact_plan: typing.Optional[ArtifactPlan] = OMIT,
        message_plan: typing.Optional[MessagePlan] = OMIT,
        start_speaking_plan: typing.Optional[StartSpeakingPlan] = OMIT,
        stop_speaking_plan: typing.Optional[StopSpeakingPlan] = OMIT,
        monitor_plan: typing.Optional[MonitorPlan] = OMIT,
        credential_ids: typing.Optional[typing.Sequence[str]] = OMIT,
        server: typing.Optional[Server] = OMIT,
        hooks: typing.Optional[typing.Sequence[AssistantHooks]] = OMIT,
        keypad_input_plan: typing.Optional[KeypadInputPlan] = OMIT,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> Assistant:
        """
        Parameters
        ----------
        transcriber : typing.Optional[CreateAssistantDtoTranscriber]
            These are the options for the assistant's transcriber.

        model : typing.Optional[CreateAssistantDtoModel]
            These are the options for the assistant's LLM.

        voice : typing.Optional[CreateAssistantDtoVoice]
            These are the options for the assistant's voice.

        first_message : typing.Optional[str]
            This is the first message that the assistant will say. This can also be a URL to a containerized audio file (mp3, wav, etc.).

            If unspecified, assistant will wait for user to speak and use the model to respond once they speak.

        first_message_interruptions_enabled : typing.Optional[bool]

        first_message_mode : typing.Optional[CreateAssistantDtoFirstMessageMode]
            This is the mode for the first message. Default is 'assistant-speaks-first'.

            Use:
            - 'assistant-speaks-first' to have the assistant speak first.
            - 'assistant-waits-for-user' to have the assistant wait for the user to speak first.
            - 'assistant-speaks-first-with-model-generated-message' to have the assistant speak first with a message generated by the model based on the conversation state. (`assistant.model.messages` at call start, `call.messages` at squad transfer points).

            @default 'assistant-speaks-first'

        voicemail_detection : typing.Optional[CreateAssistantDtoVoicemailDetection]
            These are the settings to configure or disable voicemail detection. Alternatively, voicemail detection can be configured using the model.tools=[VoicemailTool].
            This uses Twilio's built-in detection while the VoicemailTool relies on the model to detect if a voicemail was reached.
            You can use neither of them, one of them, or both of them. By default, Twilio built-in detection is enabled while VoicemailTool is not.

        client_messages : typing.Optional[typing.Sequence[CreateAssistantDtoClientMessagesItem]]
            These are the messages that will be sent to your Client SDKs. Default is conversation-update,function-call,hang,model-output,speech-update,status-update,transfer-update,transcript,tool-calls,user-interrupted,voice-input,workflow.node.started. You can check the shape of the messages in ClientMessage schema.

        server_messages : typing.Optional[typing.Sequence[CreateAssistantDtoServerMessagesItem]]
            These are the messages that will be sent to your Server URL. Default is conversation-update,end-of-call-report,function-call,hang,speech-update,status-update,tool-calls,transfer-destination-request,user-interrupted. You can check the shape of the messages in ServerMessage schema.

        silence_timeout_seconds : typing.Optional[float]
            How many seconds of silence to wait before ending the call. Defaults to 30.

            @default 30

        max_duration_seconds : typing.Optional[float]
            This is the maximum number of seconds that the call will last. When the call reaches this duration, it will be ended.

            @default 600 (10 minutes)

        background_sound : typing.Optional[CreateAssistantDtoBackgroundSound]
            This is the background sound in the call. Default for phone calls is 'office' and default for web calls is 'off'.
            You can also provide a custom sound by providing a URL to an audio file.

        background_denoising_enabled : typing.Optional[bool]
            This enables filtering of noise and background speech while the user is talking.

            Default `false` while in beta.

            @default false

        model_output_in_messages_enabled : typing.Optional[bool]
            This determines whether the model's output is used in conversation history rather than the transcription of assistant's speech.

            Default `false` while in beta.

            @default false

        transport_configurations : typing.Optional[typing.Sequence[TransportConfigurationTwilio]]
            These are the configurations to be passed to the transport providers of assistant's calls, like Twilio. You can store multiple configurations for different transport providers. For a call, only the configuration matching the call transport provider is used.

        observability_plan : typing.Optional[LangfuseObservabilityPlan]
            This is the plan for observability configuration of assistant's calls.
            Currently supports Langfuse for tracing and monitoring.

        credentials : typing.Optional[typing.Sequence[CreateAssistantDtoCredentialsItem]]
            These are dynamic credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can supplement an additional credentials using this. Dynamic credentials override existing credentials.

        name : typing.Optional[str]
            This is the name of the assistant.

            This is required when you want to transfer between assistants in a call.

        voicemail_message : typing.Optional[str]
            This is the message that the assistant will say if the call is forwarded to voicemail.

            If unspecified, it will hang up.

        end_call_message : typing.Optional[str]
            This is the message that the assistant will say if it ends the call.

            If unspecified, it will hang up without saying anything.

        end_call_phrases : typing.Optional[typing.Sequence[str]]
            This list contains phrases that, if spoken by the assistant, will trigger the call to be hung up. Case insensitive.

        compliance_plan : typing.Optional[CompliancePlan]

        metadata : typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]]
            This is for metadata you want to store on the assistant.

        analysis_plan : typing.Optional[AnalysisPlan]
            This is the plan for analysis of assistant's calls. Stored in `call.analysis`.

        artifact_plan : typing.Optional[ArtifactPlan]
            This is the plan for artifacts generated during assistant's calls. Stored in `call.artifact`.

            Note: `recordingEnabled` is currently at the root level. It will be moved to `artifactPlan` in the future, but will remain backwards compatible.

        message_plan : typing.Optional[MessagePlan]
            This is the plan for static predefined messages that can be spoken by the assistant during the call, like `idleMessages`.

            Note: `firstMessage`, `voicemailMessage`, and `endCallMessage` are currently at the root level. They will be moved to `messagePlan` in the future, but will remain backwards compatible.

        start_speaking_plan : typing.Optional[StartSpeakingPlan]
            This is the plan for when the assistant should start talking.

            You should configure this if you're running into these issues:
            - The assistant is too slow to start talking after the customer is done speaking.
            - The assistant is too fast to start talking after the customer is done speaking.
            - The assistant is so fast that it's actually interrupting the customer.

        stop_speaking_plan : typing.Optional[StopSpeakingPlan]
            This is the plan for when assistant should stop talking on customer interruption.

            You should configure this if you're running into these issues:
            - The assistant is too slow to recognize customer's interruption.
            - The assistant is too fast to recognize customer's interruption.
            - The assistant is getting interrupted by phrases that are just acknowledgments.
            - The assistant is getting interrupted by background noises.
            - The assistant is not properly stopping -- it starts talking right after getting interrupted.

        monitor_plan : typing.Optional[MonitorPlan]
            This is the plan for real-time monitoring of the assistant's calls.

            Usage:
            - To enable live listening of the assistant's calls, set `monitorPlan.listenEnabled` to `true`.
            - To enable live control of the assistant's calls, set `monitorPlan.controlEnabled` to `true`.

            Note, `serverMessages`, `clientMessages`, `serverUrl` and `serverUrlSecret` are currently at the root level but will be moved to `monitorPlan` in the future. Will remain backwards compatible

        credential_ids : typing.Optional[typing.Sequence[str]]
            These are the credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can provide a subset using this.

        server : typing.Optional[Server]
            This is where Vapi will send webhooks. You can find all webhooks available along with their shape in ServerMessage schema.

            The order of precedence is:

            1. assistant.server.url
            2. phoneNumber.serverUrl
            3. org.serverUrl

        hooks : typing.Optional[typing.Sequence[AssistantHooks]]
            This is a set of actions that will be performed on certain events.

        keypad_input_plan : typing.Optional[KeypadInputPlan]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = self._raw_client.create(
            transcriber=transcriber,
            model=model,
            voice=voice,
            first_message=first_message,
            first_message_interruptions_enabled=first_message_interruptions_enabled,
            first_message_mode=first_message_mode,
            voicemail_detection=voicemail_detection,
            client_messages=client_messages,
            server_messages=server_messages,
            silence_timeout_seconds=silence_timeout_seconds,
            max_duration_seconds=max_duration_seconds,
            background_sound=background_sound,
            background_denoising_enabled=background_denoising_enabled,
            model_output_in_messages_enabled=model_output_in_messages_enabled,
            transport_configurations=transport_configurations,
            observability_plan=observability_plan,
            credentials=credentials,
            name=name,
            voicemail_message=voicemail_message,
            end_call_message=end_call_message,
            end_call_phrases=end_call_phrases,
            compliance_plan=compliance_plan,
            metadata=metadata,
            analysis_plan=analysis_plan,
            artifact_plan=artifact_plan,
            message_plan=message_plan,
            start_speaking_plan=start_speaking_plan,
            stop_speaking_plan=stop_speaking_plan,
            monitor_plan=monitor_plan,
            credential_ids=credential_ids,
            server=server,
            hooks=hooks,
            keypad_input_plan=keypad_input_plan,
            request_options=request_options,
        )
        return response.data

    def get(self, id: str, *, request_options: typing.Optional[RequestOptions] = None) -> Assistant:
        """
        Parameters
        ----------
        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = self._raw_client.get(id, request_options=request_options)
        return response.data

    def delete(self, id: str, *, request_options: typing.Optional[RequestOptions] = None) -> Assistant:
        """
        Parameters
        ----------
        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = self._raw_client.delete(id, request_options=request_options)
        return response.data

    def update(
        self,
        id: str,
        *,
        transcriber: typing.Optional[UpdateAssistantDtoTranscriber] = OMIT,
        model: typing.Optional[UpdateAssistantDtoModel] = OMIT,
        voice: typing.Optional[UpdateAssistantDtoVoice] = OMIT,
        first_message: typing.Optional[str] = OMIT,
        first_message_interruptions_enabled: typing.Optional[bool] = OMIT,
        first_message_mode: typing.Optional[UpdateAssistantDtoFirstMessageMode] = OMIT,
        voicemail_detection: typing.Optional[UpdateAssistantDtoVoicemailDetection] = OMIT,
        client_messages: typing.Optional[typing.Sequence[UpdateAssistantDtoClientMessagesItem]] = OMIT,
        server_messages: typing.Optional[typing.Sequence[UpdateAssistantDtoServerMessagesItem]] = OMIT,
        silence_timeout_seconds: typing.Optional[float] = OMIT,
        max_duration_seconds: typing.Optional[float] = OMIT,
        background_sound: typing.Optional[UpdateAssistantDtoBackgroundSound] = OMIT,
        background_denoising_enabled: typing.Optional[bool] = OMIT,
        model_output_in_messages_enabled: typing.Optional[bool] = OMIT,
        transport_configurations: typing.Optional[typing.Sequence[TransportConfigurationTwilio]] = OMIT,
        observability_plan: typing.Optional[LangfuseObservabilityPlan] = OMIT,
        credentials: typing.Optional[typing.Sequence[UpdateAssistantDtoCredentialsItem]] = OMIT,
        name: typing.Optional[str] = OMIT,
        voicemail_message: typing.Optional[str] = OMIT,
        end_call_message: typing.Optional[str] = OMIT,
        end_call_phrases: typing.Optional[typing.Sequence[str]] = OMIT,
        compliance_plan: typing.Optional[CompliancePlan] = OMIT,
        metadata: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = OMIT,
        analysis_plan: typing.Optional[AnalysisPlan] = OMIT,
        artifact_plan: typing.Optional[ArtifactPlan] = OMIT,
        message_plan: typing.Optional[MessagePlan] = OMIT,
        start_speaking_plan: typing.Optional[StartSpeakingPlan] = OMIT,
        stop_speaking_plan: typing.Optional[StopSpeakingPlan] = OMIT,
        monitor_plan: typing.Optional[MonitorPlan] = OMIT,
        credential_ids: typing.Optional[typing.Sequence[str]] = OMIT,
        server: typing.Optional[Server] = OMIT,
        hooks: typing.Optional[typing.Sequence[AssistantHooks]] = OMIT,
        keypad_input_plan: typing.Optional[KeypadInputPlan] = OMIT,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> Assistant:
        """
        Parameters
        ----------
        id : str

        transcriber : typing.Optional[UpdateAssistantDtoTranscriber]
            These are the options for the assistant's transcriber.

        model : typing.Optional[UpdateAssistantDtoModel]
            These are the options for the assistant's LLM.

        voice : typing.Optional[UpdateAssistantDtoVoice]
            These are the options for the assistant's voice.

        first_message : typing.Optional[str]
            This is the first message that the assistant will say. This can also be a URL to a containerized audio file (mp3, wav, etc.).

            If unspecified, assistant will wait for user to speak and use the model to respond once they speak.

        first_message_interruptions_enabled : typing.Optional[bool]

        first_message_mode : typing.Optional[UpdateAssistantDtoFirstMessageMode]
            This is the mode for the first message. Default is 'assistant-speaks-first'.

            Use:
            - 'assistant-speaks-first' to have the assistant speak first.
            - 'assistant-waits-for-user' to have the assistant wait for the user to speak first.
            - 'assistant-speaks-first-with-model-generated-message' to have the assistant speak first with a message generated by the model based on the conversation state. (`assistant.model.messages` at call start, `call.messages` at squad transfer points).

            @default 'assistant-speaks-first'

        voicemail_detection : typing.Optional[UpdateAssistantDtoVoicemailDetection]
            These are the settings to configure or disable voicemail detection. Alternatively, voicemail detection can be configured using the model.tools=[VoicemailTool].
            This uses Twilio's built-in detection while the VoicemailTool relies on the model to detect if a voicemail was reached.
            You can use neither of them, one of them, or both of them. By default, Twilio built-in detection is enabled while VoicemailTool is not.

        client_messages : typing.Optional[typing.Sequence[UpdateAssistantDtoClientMessagesItem]]
            These are the messages that will be sent to your Client SDKs. Default is conversation-update,function-call,hang,model-output,speech-update,status-update,transfer-update,transcript,tool-calls,user-interrupted,voice-input,workflow.node.started. You can check the shape of the messages in ClientMessage schema.

        server_messages : typing.Optional[typing.Sequence[UpdateAssistantDtoServerMessagesItem]]
            These are the messages that will be sent to your Server URL. Default is conversation-update,end-of-call-report,function-call,hang,speech-update,status-update,tool-calls,transfer-destination-request,user-interrupted. You can check the shape of the messages in ServerMessage schema.

        silence_timeout_seconds : typing.Optional[float]
            How many seconds of silence to wait before ending the call. Defaults to 30.

            @default 30

        max_duration_seconds : typing.Optional[float]
            This is the maximum number of seconds that the call will last. When the call reaches this duration, it will be ended.

            @default 600 (10 minutes)

        background_sound : typing.Optional[UpdateAssistantDtoBackgroundSound]
            This is the background sound in the call. Default for phone calls is 'office' and default for web calls is 'off'.
            You can also provide a custom sound by providing a URL to an audio file.

        background_denoising_enabled : typing.Optional[bool]
            This enables filtering of noise and background speech while the user is talking.

            Default `false` while in beta.

            @default false

        model_output_in_messages_enabled : typing.Optional[bool]
            This determines whether the model's output is used in conversation history rather than the transcription of assistant's speech.

            Default `false` while in beta.

            @default false

        transport_configurations : typing.Optional[typing.Sequence[TransportConfigurationTwilio]]
            These are the configurations to be passed to the transport providers of assistant's calls, like Twilio. You can store multiple configurations for different transport providers. For a call, only the configuration matching the call transport provider is used.

        observability_plan : typing.Optional[LangfuseObservabilityPlan]
            This is the plan for observability configuration of assistant's calls.
            Currently supports Langfuse for tracing and monitoring.

        credentials : typing.Optional[typing.Sequence[UpdateAssistantDtoCredentialsItem]]
            These are dynamic credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can supplement an additional credentials using this. Dynamic credentials override existing credentials.

        name : typing.Optional[str]
            This is the name of the assistant.

            This is required when you want to transfer between assistants in a call.

        voicemail_message : typing.Optional[str]
            This is the message that the assistant will say if the call is forwarded to voicemail.

            If unspecified, it will hang up.

        end_call_message : typing.Optional[str]
            This is the message that the assistant will say if it ends the call.

            If unspecified, it will hang up without saying anything.

        end_call_phrases : typing.Optional[typing.Sequence[str]]
            This list contains phrases that, if spoken by the assistant, will trigger the call to be hung up. Case insensitive.

        compliance_plan : typing.Optional[CompliancePlan]

        metadata : typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]]
            This is for metadata you want to store on the assistant.

        analysis_plan : typing.Optional[AnalysisPlan]
            This is the plan for analysis of assistant's calls. Stored in `call.analysis`.

        artifact_plan : typing.Optional[ArtifactPlan]
            This is the plan for artifacts generated during assistant's calls. Stored in `call.artifact`.

            Note: `recordingEnabled` is currently at the root level. It will be moved to `artifactPlan` in the future, but will remain backwards compatible.

        message_plan : typing.Optional[MessagePlan]
            This is the plan for static predefined messages that can be spoken by the assistant during the call, like `idleMessages`.

            Note: `firstMessage`, `voicemailMessage`, and `endCallMessage` are currently at the root level. They will be moved to `messagePlan` in the future, but will remain backwards compatible.

        start_speaking_plan : typing.Optional[StartSpeakingPlan]
            This is the plan for when the assistant should start talking.

            You should configure this if you're running into these issues:
            - The assistant is too slow to start talking after the customer is done speaking.
            - The assistant is too fast to start talking after the customer is done speaking.
            - The assistant is so fast that it's actually interrupting the customer.

        stop_speaking_plan : typing.Optional[StopSpeakingPlan]
            This is the plan for when assistant should stop talking on customer interruption.

            You should configure this if you're running into these issues:
            - The assistant is too slow to recognize customer's interruption.
            - The assistant is too fast to recognize customer's interruption.
            - The assistant is getting interrupted by phrases that are just acknowledgments.
            - The assistant is getting interrupted by background noises.
            - The assistant is not properly stopping -- it starts talking right after getting interrupted.

        monitor_plan : typing.Optional[MonitorPlan]
            This is the plan for real-time monitoring of the assistant's calls.

            Usage:
            - To enable live listening of the assistant's calls, set `monitorPlan.listenEnabled` to `true`.
            - To enable live control of the assistant's calls, set `monitorPlan.controlEnabled` to `true`.

            Note, `serverMessages`, `clientMessages`, `serverUrl` and `serverUrlSecret` are currently at the root level but will be moved to `monitorPlan` in the future. Will remain backwards compatible

        credential_ids : typing.Optional[typing.Sequence[str]]
            These are the credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can provide a subset using this.

        server : typing.Optional[Server]
            This is where Vapi will send webhooks. You can find all webhooks available along with their shape in ServerMessage schema.

            The order of precedence is:

            1. assistant.server.url
            2. phoneNumber.serverUrl
            3. org.serverUrl

        hooks : typing.Optional[typing.Sequence[AssistantHooks]]
            This is a set of actions that will be performed on certain events.

        keypad_input_plan : typing.Optional[KeypadInputPlan]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = self._raw_client.update(
            id,
            transcriber=transcriber,
            model=model,
            voice=voice,
            first_message=first_message,
            first_message_interruptions_enabled=first_message_interruptions_enabled,
            first_message_mode=first_message_mode,
            voicemail_detection=voicemail_detection,
            client_messages=client_messages,
            server_messages=server_messages,
            silence_timeout_seconds=silence_timeout_seconds,
            max_duration_seconds=max_duration_seconds,
            background_sound=background_sound,
            background_denoising_enabled=background_denoising_enabled,
            model_output_in_messages_enabled=model_output_in_messages_enabled,
            transport_configurations=transport_configurations,
            observability_plan=observability_plan,
            credentials=credentials,
            name=name,
            voicemail_message=voicemail_message,
            end_call_message=end_call_message,
            end_call_phrases=end_call_phrases,
            compliance_plan=compliance_plan,
            metadata=metadata,
            analysis_plan=analysis_plan,
            artifact_plan=artifact_plan,
            message_plan=message_plan,
            start_speaking_plan=start_speaking_plan,
            stop_speaking_plan=stop_speaking_plan,
            monitor_plan=monitor_plan,
            credential_ids=credential_ids,
            server=server,
            hooks=hooks,
            keypad_input_plan=keypad_input_plan,
            request_options=request_options,
        )
        return response.data


class AsyncAssistantsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawAssistantsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawAssistantsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawAssistantsClient
        """
        return self._raw_client

    async def list(
        self,
        *,
        limit: typing.Optional[float] = None,
        created_at_gt: typing.Optional[dt.datetime] = None,
        created_at_lt: typing.Optional[dt.datetime] = None,
        created_at_ge: typing.Optional[dt.datetime] = None,
        created_at_le: typing.Optional[dt.datetime] = None,
        updated_at_gt: typing.Optional[dt.datetime] = None,
        updated_at_lt: typing.Optional[dt.datetime] = None,
        updated_at_ge: typing.Optional[dt.datetime] = None,
        updated_at_le: typing.Optional[dt.datetime] = None,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> typing.List[Assistant]:
        """
        Parameters
        ----------
        limit : typing.Optional[float]
            This is the maximum number of items to return. Defaults to 100.

        created_at_gt : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than the specified value.

        created_at_lt : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than the specified value.

        created_at_ge : typing.Optional[dt.datetime]
            This will return items where the createdAt is greater than or equal to the specified value.

        created_at_le : typing.Optional[dt.datetime]
            This will return items where the createdAt is less than or equal to the specified value.

        updated_at_gt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than the specified value.

        updated_at_lt : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than the specified value.

        updated_at_ge : typing.Optional[dt.datetime]
            This will return items where the updatedAt is greater than or equal to the specified value.

        updated_at_le : typing.Optional[dt.datetime]
            This will return items where the updatedAt is less than or equal to the specified value.

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        typing.List[Assistant]

        """
        response = await self._raw_client.list(
            limit=limit,
            created_at_gt=created_at_gt,
            created_at_lt=created_at_lt,
            created_at_ge=created_at_ge,
            created_at_le=created_at_le,
            updated_at_gt=updated_at_gt,
            updated_at_lt=updated_at_lt,
            updated_at_ge=updated_at_ge,
            updated_at_le=updated_at_le,
            request_options=request_options,
        )
        return response.data

    async def create(
        self,
        *,
        transcriber: typing.Optional[CreateAssistantDtoTranscriber] = OMIT,
        model: typing.Optional[CreateAssistantDtoModel] = OMIT,
        voice: typing.Optional[CreateAssistantDtoVoice] = OMIT,
        first_message: typing.Optional[str] = OMIT,
        first_message_interruptions_enabled: typing.Optional[bool] = OMIT,
        first_message_mode: typing.Optional[CreateAssistantDtoFirstMessageMode] = OMIT,
        voicemail_detection: typing.Optional[CreateAssistantDtoVoicemailDetection] = OMIT,
        client_messages: typing.Optional[typing.Sequence[CreateAssistantDtoClientMessagesItem]] = OMIT,
        server_messages: typing.Optional[typing.Sequence[CreateAssistantDtoServerMessagesItem]] = OMIT,
        silence_timeout_seconds: typing.Optional[float] = OMIT,
        max_duration_seconds: typing.Optional[float] = OMIT,
        background_sound: typing.Optional[CreateAssistantDtoBackgroundSound] = OMIT,
        background_denoising_enabled: typing.Optional[bool] = OMIT,
        model_output_in_messages_enabled: typing.Optional[bool] = OMIT,
        transport_configurations: typing.Optional[typing.Sequence[TransportConfigurationTwilio]] = OMIT,
        observability_plan: typing.Optional[LangfuseObservabilityPlan] = OMIT,
        credentials: typing.Optional[typing.Sequence[CreateAssistantDtoCredentialsItem]] = OMIT,
        name: typing.Optional[str] = OMIT,
        voicemail_message: typing.Optional[str] = OMIT,
        end_call_message: typing.Optional[str] = OMIT,
        end_call_phrases: typing.Optional[typing.Sequence[str]] = OMIT,
        compliance_plan: typing.Optional[CompliancePlan] = OMIT,
        metadata: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = OMIT,
        analysis_plan: typing.Optional[AnalysisPlan] = OMIT,
        artifact_plan: typing.Optional[ArtifactPlan] = OMIT,
        message_plan: typing.Optional[MessagePlan] = OMIT,
        start_speaking_plan: typing.Optional[StartSpeakingPlan] = OMIT,
        stop_speaking_plan: typing.Optional[StopSpeakingPlan] = OMIT,
        monitor_plan: typing.Optional[MonitorPlan] = OMIT,
        credential_ids: typing.Optional[typing.Sequence[str]] = OMIT,
        server: typing.Optional[Server] = OMIT,
        hooks: typing.Optional[typing.Sequence[AssistantHooks]] = OMIT,
        keypad_input_plan: typing.Optional[KeypadInputPlan] = OMIT,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> Assistant:
        """
        Parameters
        ----------
        transcriber : typing.Optional[CreateAssistantDtoTranscriber]
            These are the options for the assistant's transcriber.

        model : typing.Optional[CreateAssistantDtoModel]
            These are the options for the assistant's LLM.

        voice : typing.Optional[CreateAssistantDtoVoice]
            These are the options for the assistant's voice.

        first_message : typing.Optional[str]
            This is the first message that the assistant will say. This can also be a URL to a containerized audio file (mp3, wav, etc.).

            If unspecified, assistant will wait for user to speak and use the model to respond once they speak.

        first_message_interruptions_enabled : typing.Optional[bool]

        first_message_mode : typing.Optional[CreateAssistantDtoFirstMessageMode]
            This is the mode for the first message. Default is 'assistant-speaks-first'.

            Use:
            - 'assistant-speaks-first' to have the assistant speak first.
            - 'assistant-waits-for-user' to have the assistant wait for the user to speak first.
            - 'assistant-speaks-first-with-model-generated-message' to have the assistant speak first with a message generated by the model based on the conversation state. (`assistant.model.messages` at call start, `call.messages` at squad transfer points).

            @default 'assistant-speaks-first'

        voicemail_detection : typing.Optional[CreateAssistantDtoVoicemailDetection]
            These are the settings to configure or disable voicemail detection. Alternatively, voicemail detection can be configured using the model.tools=[VoicemailTool].
            This uses Twilio's built-in detection while the VoicemailTool relies on the model to detect if a voicemail was reached.
            You can use neither of them, one of them, or both of them. By default, Twilio built-in detection is enabled while VoicemailTool is not.

        client_messages : typing.Optional[typing.Sequence[CreateAssistantDtoClientMessagesItem]]
            These are the messages that will be sent to your Client SDKs. Default is conversation-update,function-call,hang,model-output,speech-update,status-update,transfer-update,transcript,tool-calls,user-interrupted,voice-input,workflow.node.started. You can check the shape of the messages in ClientMessage schema.

        server_messages : typing.Optional[typing.Sequence[CreateAssistantDtoServerMessagesItem]]
            These are the messages that will be sent to your Server URL. Default is conversation-update,end-of-call-report,function-call,hang,speech-update,status-update,tool-calls,transfer-destination-request,user-interrupted. You can check the shape of the messages in ServerMessage schema.

        silence_timeout_seconds : typing.Optional[float]
            How many seconds of silence to wait before ending the call. Defaults to 30.

            @default 30

        max_duration_seconds : typing.Optional[float]
            This is the maximum number of seconds that the call will last. When the call reaches this duration, it will be ended.

            @default 600 (10 minutes)

        background_sound : typing.Optional[CreateAssistantDtoBackgroundSound]
            This is the background sound in the call. Default for phone calls is 'office' and default for web calls is 'off'.
            You can also provide a custom sound by providing a URL to an audio file.

        background_denoising_enabled : typing.Optional[bool]
            This enables filtering of noise and background speech while the user is talking.

            Default `false` while in beta.

            @default false

        model_output_in_messages_enabled : typing.Optional[bool]
            This determines whether the model's output is used in conversation history rather than the transcription of assistant's speech.

            Default `false` while in beta.

            @default false

        transport_configurations : typing.Optional[typing.Sequence[TransportConfigurationTwilio]]
            These are the configurations to be passed to the transport providers of assistant's calls, like Twilio. You can store multiple configurations for different transport providers. For a call, only the configuration matching the call transport provider is used.

        observability_plan : typing.Optional[LangfuseObservabilityPlan]
            This is the plan for observability configuration of assistant's calls.
            Currently supports Langfuse for tracing and monitoring.

        credentials : typing.Optional[typing.Sequence[CreateAssistantDtoCredentialsItem]]
            These are dynamic credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can supplement an additional credentials using this. Dynamic credentials override existing credentials.

        name : typing.Optional[str]
            This is the name of the assistant.

            This is required when you want to transfer between assistants in a call.

        voicemail_message : typing.Optional[str]
            This is the message that the assistant will say if the call is forwarded to voicemail.

            If unspecified, it will hang up.

        end_call_message : typing.Optional[str]
            This is the message that the assistant will say if it ends the call.

            If unspecified, it will hang up without saying anything.

        end_call_phrases : typing.Optional[typing.Sequence[str]]
            This list contains phrases that, if spoken by the assistant, will trigger the call to be hung up. Case insensitive.

        compliance_plan : typing.Optional[CompliancePlan]

        metadata : typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]]
            This is for metadata you want to store on the assistant.

        analysis_plan : typing.Optional[AnalysisPlan]
            This is the plan for analysis of assistant's calls. Stored in `call.analysis`.

        artifact_plan : typing.Optional[ArtifactPlan]
            This is the plan for artifacts generated during assistant's calls. Stored in `call.artifact`.

            Note: `recordingEnabled` is currently at the root level. It will be moved to `artifactPlan` in the future, but will remain backwards compatible.

        message_plan : typing.Optional[MessagePlan]
            This is the plan for static predefined messages that can be spoken by the assistant during the call, like `idleMessages`.

            Note: `firstMessage`, `voicemailMessage`, and `endCallMessage` are currently at the root level. They will be moved to `messagePlan` in the future, but will remain backwards compatible.

        start_speaking_plan : typing.Optional[StartSpeakingPlan]
            This is the plan for when the assistant should start talking.

            You should configure this if you're running into these issues:
            - The assistant is too slow to start talking after the customer is done speaking.
            - The assistant is too fast to start talking after the customer is done speaking.
            - The assistant is so fast that it's actually interrupting the customer.

        stop_speaking_plan : typing.Optional[StopSpeakingPlan]
            This is the plan for when assistant should stop talking on customer interruption.

            You should configure this if you're running into these issues:
            - The assistant is too slow to recognize customer's interruption.
            - The assistant is too fast to recognize customer's interruption.
            - The assistant is getting interrupted by phrases that are just acknowledgments.
            - The assistant is getting interrupted by background noises.
            - The assistant is not properly stopping -- it starts talking right after getting interrupted.

        monitor_plan : typing.Optional[MonitorPlan]
            This is the plan for real-time monitoring of the assistant's calls.

            Usage:
            - To enable live listening of the assistant's calls, set `monitorPlan.listenEnabled` to `true`.
            - To enable live control of the assistant's calls, set `monitorPlan.controlEnabled` to `true`.

            Note, `serverMessages`, `clientMessages`, `serverUrl` and `serverUrlSecret` are currently at the root level but will be moved to `monitorPlan` in the future. Will remain backwards compatible

        credential_ids : typing.Optional[typing.Sequence[str]]
            These are the credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can provide a subset using this.

        server : typing.Optional[Server]
            This is where Vapi will send webhooks. You can find all webhooks available along with their shape in ServerMessage schema.

            The order of precedence is:

            1. assistant.server.url
            2. phoneNumber.serverUrl
            3. org.serverUrl

        hooks : typing.Optional[typing.Sequence[AssistantHooks]]
            This is a set of actions that will be performed on certain events.

        keypad_input_plan : typing.Optional[KeypadInputPlan]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = await self._raw_client.create(
            transcriber=transcriber,
            model=model,
            voice=voice,
            first_message=first_message,
            first_message_interruptions_enabled=first_message_interruptions_enabled,
            first_message_mode=first_message_mode,
            voicemail_detection=voicemail_detection,
            client_messages=client_messages,
            server_messages=server_messages,
            silence_timeout_seconds=silence_timeout_seconds,
            max_duration_seconds=max_duration_seconds,
            background_sound=background_sound,
            background_denoising_enabled=background_denoising_enabled,
            model_output_in_messages_enabled=model_output_in_messages_enabled,
            transport_configurations=transport_configurations,
            observability_plan=observability_plan,
            credentials=credentials,
            name=name,
            voicemail_message=voicemail_message,
            end_call_message=end_call_message,
            end_call_phrases=end_call_phrases,
            compliance_plan=compliance_plan,
            metadata=metadata,
            analysis_plan=analysis_plan,
            artifact_plan=artifact_plan,
            message_plan=message_plan,
            start_speaking_plan=start_speaking_plan,
            stop_speaking_plan=stop_speaking_plan,
            monitor_plan=monitor_plan,
            credential_ids=credential_ids,
            server=server,
            hooks=hooks,
            keypad_input_plan=keypad_input_plan,
            request_options=request_options,
        )
        return response.data

    async def get(self, id: str, *, request_options: typing.Optional[RequestOptions] = None) -> Assistant:
        """
        Parameters
        ----------
        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = await self._raw_client.get(id, request_options=request_options)
        return response.data

    async def delete(self, id: str, *, request_options: typing.Optional[RequestOptions] = None) -> Assistant:
        """
        Parameters
        ----------
        id : str

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = await self._raw_client.delete(id, request_options=request_options)
        return response.data

    async def update(
        self,
        id: str,
        *,
        transcriber: typing.Optional[UpdateAssistantDtoTranscriber] = OMIT,
        model: typing.Optional[UpdateAssistantDtoModel] = OMIT,
        voice: typing.Optional[UpdateAssistantDtoVoice] = OMIT,
        first_message: typing.Optional[str] = OMIT,
        first_message_interruptions_enabled: typing.Optional[bool] = OMIT,
        first_message_mode: typing.Optional[UpdateAssistantDtoFirstMessageMode] = OMIT,
        voicemail_detection: typing.Optional[UpdateAssistantDtoVoicemailDetection] = OMIT,
        client_messages: typing.Optional[typing.Sequence[UpdateAssistantDtoClientMessagesItem]] = OMIT,
        server_messages: typing.Optional[typing.Sequence[UpdateAssistantDtoServerMessagesItem]] = OMIT,
        silence_timeout_seconds: typing.Optional[float] = OMIT,
        max_duration_seconds: typing.Optional[float] = OMIT,
        background_sound: typing.Optional[UpdateAssistantDtoBackgroundSound] = OMIT,
        background_denoising_enabled: typing.Optional[bool] = OMIT,
        model_output_in_messages_enabled: typing.Optional[bool] = OMIT,
        transport_configurations: typing.Optional[typing.Sequence[TransportConfigurationTwilio]] = OMIT,
        observability_plan: typing.Optional[LangfuseObservabilityPlan] = OMIT,
        credentials: typing.Optional[typing.Sequence[UpdateAssistantDtoCredentialsItem]] = OMIT,
        name: typing.Optional[str] = OMIT,
        voicemail_message: typing.Optional[str] = OMIT,
        end_call_message: typing.Optional[str] = OMIT,
        end_call_phrases: typing.Optional[typing.Sequence[str]] = OMIT,
        compliance_plan: typing.Optional[CompliancePlan] = OMIT,
        metadata: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = OMIT,
        analysis_plan: typing.Optional[AnalysisPlan] = OMIT,
        artifact_plan: typing.Optional[ArtifactPlan] = OMIT,
        message_plan: typing.Optional[MessagePlan] = OMIT,
        start_speaking_plan: typing.Optional[StartSpeakingPlan] = OMIT,
        stop_speaking_plan: typing.Optional[StopSpeakingPlan] = OMIT,
        monitor_plan: typing.Optional[MonitorPlan] = OMIT,
        credential_ids: typing.Optional[typing.Sequence[str]] = OMIT,
        server: typing.Optional[Server] = OMIT,
        hooks: typing.Optional[typing.Sequence[AssistantHooks]] = OMIT,
        keypad_input_plan: typing.Optional[KeypadInputPlan] = OMIT,
        request_options: typing.Optional[RequestOptions] = None,
    ) -> Assistant:
        """
        Parameters
        ----------
        id : str

        transcriber : typing.Optional[UpdateAssistantDtoTranscriber]
            These are the options for the assistant's transcriber.

        model : typing.Optional[UpdateAssistantDtoModel]
            These are the options for the assistant's LLM.

        voice : typing.Optional[UpdateAssistantDtoVoice]
            These are the options for the assistant's voice.

        first_message : typing.Optional[str]
            This is the first message that the assistant will say. This can also be a URL to a containerized audio file (mp3, wav, etc.).

            If unspecified, assistant will wait for user to speak and use the model to respond once they speak.

        first_message_interruptions_enabled : typing.Optional[bool]

        first_message_mode : typing.Optional[UpdateAssistantDtoFirstMessageMode]
            This is the mode for the first message. Default is 'assistant-speaks-first'.

            Use:
            - 'assistant-speaks-first' to have the assistant speak first.
            - 'assistant-waits-for-user' to have the assistant wait for the user to speak first.
            - 'assistant-speaks-first-with-model-generated-message' to have the assistant speak first with a message generated by the model based on the conversation state. (`assistant.model.messages` at call start, `call.messages` at squad transfer points).

            @default 'assistant-speaks-first'

        voicemail_detection : typing.Optional[UpdateAssistantDtoVoicemailDetection]
            These are the settings to configure or disable voicemail detection. Alternatively, voicemail detection can be configured using the model.tools=[VoicemailTool].
            This uses Twilio's built-in detection while the VoicemailTool relies on the model to detect if a voicemail was reached.
            You can use neither of them, one of them, or both of them. By default, Twilio built-in detection is enabled while VoicemailTool is not.

        client_messages : typing.Optional[typing.Sequence[UpdateAssistantDtoClientMessagesItem]]
            These are the messages that will be sent to your Client SDKs. Default is conversation-update,function-call,hang,model-output,speech-update,status-update,transfer-update,transcript,tool-calls,user-interrupted,voice-input,workflow.node.started. You can check the shape of the messages in ClientMessage schema.

        server_messages : typing.Optional[typing.Sequence[UpdateAssistantDtoServerMessagesItem]]
            These are the messages that will be sent to your Server URL. Default is conversation-update,end-of-call-report,function-call,hang,speech-update,status-update,tool-calls,transfer-destination-request,user-interrupted. You can check the shape of the messages in ServerMessage schema.

        silence_timeout_seconds : typing.Optional[float]
            How many seconds of silence to wait before ending the call. Defaults to 30.

            @default 30

        max_duration_seconds : typing.Optional[float]
            This is the maximum number of seconds that the call will last. When the call reaches this duration, it will be ended.

            @default 600 (10 minutes)

        background_sound : typing.Optional[UpdateAssistantDtoBackgroundSound]
            This is the background sound in the call. Default for phone calls is 'office' and default for web calls is 'off'.
            You can also provide a custom sound by providing a URL to an audio file.

        background_denoising_enabled : typing.Optional[bool]
            This enables filtering of noise and background speech while the user is talking.

            Default `false` while in beta.

            @default false

        model_output_in_messages_enabled : typing.Optional[bool]
            This determines whether the model's output is used in conversation history rather than the transcription of assistant's speech.

            Default `false` while in beta.

            @default false

        transport_configurations : typing.Optional[typing.Sequence[TransportConfigurationTwilio]]
            These are the configurations to be passed to the transport providers of assistant's calls, like Twilio. You can store multiple configurations for different transport providers. For a call, only the configuration matching the call transport provider is used.

        observability_plan : typing.Optional[LangfuseObservabilityPlan]
            This is the plan for observability configuration of assistant's calls.
            Currently supports Langfuse for tracing and monitoring.

        credentials : typing.Optional[typing.Sequence[UpdateAssistantDtoCredentialsItem]]
            These are dynamic credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can supplement an additional credentials using this. Dynamic credentials override existing credentials.

        name : typing.Optional[str]
            This is the name of the assistant.

            This is required when you want to transfer between assistants in a call.

        voicemail_message : typing.Optional[str]
            This is the message that the assistant will say if the call is forwarded to voicemail.

            If unspecified, it will hang up.

        end_call_message : typing.Optional[str]
            This is the message that the assistant will say if it ends the call.

            If unspecified, it will hang up without saying anything.

        end_call_phrases : typing.Optional[typing.Sequence[str]]
            This list contains phrases that, if spoken by the assistant, will trigger the call to be hung up. Case insensitive.

        compliance_plan : typing.Optional[CompliancePlan]

        metadata : typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]]
            This is for metadata you want to store on the assistant.

        analysis_plan : typing.Optional[AnalysisPlan]
            This is the plan for analysis of assistant's calls. Stored in `call.analysis`.

        artifact_plan : typing.Optional[ArtifactPlan]
            This is the plan for artifacts generated during assistant's calls. Stored in `call.artifact`.

            Note: `recordingEnabled` is currently at the root level. It will be moved to `artifactPlan` in the future, but will remain backwards compatible.

        message_plan : typing.Optional[MessagePlan]
            This is the plan for static predefined messages that can be spoken by the assistant during the call, like `idleMessages`.

            Note: `firstMessage`, `voicemailMessage`, and `endCallMessage` are currently at the root level. They will be moved to `messagePlan` in the future, but will remain backwards compatible.

        start_speaking_plan : typing.Optional[StartSpeakingPlan]
            This is the plan for when the assistant should start talking.

            You should configure this if you're running into these issues:
            - The assistant is too slow to start talking after the customer is done speaking.
            - The assistant is too fast to start talking after the customer is done speaking.
            - The assistant is so fast that it's actually interrupting the customer.

        stop_speaking_plan : typing.Optional[StopSpeakingPlan]
            This is the plan for when assistant should stop talking on customer interruption.

            You should configure this if you're running into these issues:
            - The assistant is too slow to recognize customer's interruption.
            - The assistant is too fast to recognize customer's interruption.
            - The assistant is getting interrupted by phrases that are just acknowledgments.
            - The assistant is getting interrupted by background noises.
            - The assistant is not properly stopping -- it starts talking right after getting interrupted.

        monitor_plan : typing.Optional[MonitorPlan]
            This is the plan for real-time monitoring of the assistant's calls.

            Usage:
            - To enable live listening of the assistant's calls, set `monitorPlan.listenEnabled` to `true`.
            - To enable live control of the assistant's calls, set `monitorPlan.controlEnabled` to `true`.

            Note, `serverMessages`, `clientMessages`, `serverUrl` and `serverUrlSecret` are currently at the root level but will be moved to `monitorPlan` in the future. Will remain backwards compatible

        credential_ids : typing.Optional[typing.Sequence[str]]
            These are the credentials that will be used for the assistant calls. By default, all the credentials are available for use in the call but you can provide a subset using this.

        server : typing.Optional[Server]
            This is where Vapi will send webhooks. You can find all webhooks available along with their shape in ServerMessage schema.

            The order of precedence is:

            1. assistant.server.url
            2. phoneNumber.serverUrl
            3. org.serverUrl

        hooks : typing.Optional[typing.Sequence[AssistantHooks]]
            This is a set of actions that will be performed on certain events.

        keypad_input_plan : typing.Optional[KeypadInputPlan]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        Assistant

        """
        response = await self._raw_client.update(
            id,
            transcriber=transcriber,
            model=model,
            voice=voice,
            first_message=first_message,
            first_message_interruptions_enabled=first_message_interruptions_enabled,
            first_message_mode=first_message_mode,
            voicemail_detection=voicemail_detection,
            client_messages=client_messages,
            server_messages=server_messages,
            silence_timeout_seconds=silence_timeout_seconds,
            max_duration_seconds=max_duration_seconds,
            background_sound=background_sound,
            background_denoising_enabled=background_denoising_enabled,
            model_output_in_messages_enabled=model_output_in_messages_enabled,
            transport_configurations=transport_configurations,
            observability_plan=observability_plan,
            credentials=credentials,
            name=name,
            voicemail_message=voicemail_message,
            end_call_message=end_call_message,
            end_call_phrases=end_call_phrases,
            compliance_plan=compliance_plan,
            metadata=metadata,
            analysis_plan=analysis_plan,
            artifact_plan=artifact_plan,
            message_plan=message_plan,
            start_speaking_plan=start_speaking_plan,
            stop_speaking_plan=stop_speaking_plan,
            monitor_plan=monitor_plan,
            credential_ids=credential_ids,
            server=server,
            hooks=hooks,
            keypad_input_plan=keypad_input_plan,
            request_options=request_options,
        )
        return response.data
