# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .fallback_azure_speech_transcriber_language import FallbackAzureSpeechTranscriberLanguage
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FallbackAzureSpeechTranscriber(UncheckedBaseModel):
    provider: typing.Literal["azure"] = pydantic.Field(default="azure")
    """
    This is the transcription provider that will be used.
    """

    language: typing.Optional[FallbackAzureSpeechTranscriberLanguage] = pydantic.Field(default=None)
    """
    This is the language that will be set for the transcription. The list of languages Azure supports can be found here: https://learn.microsoft.com/en-us/azure/ai-services/speech-service/language-support?tabs=stt
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
