# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class MessagePlan(UncheckedBaseModel):
    idle_messages: typing_extensions.Annotated[
        typing.Optional[typing.List[str]], FieldMetadata(alias="idleMessages")
    ] = pydantic.Field(default=None)
    """
    This are the messages that the assistant will speak when the user hasn't responded for `idleTimeoutSeconds`. Each time the timeout is triggered, a random message will be chosen from this array.
    
    Usage:
    - If user gets distracted and doesn't respond for a while, this can be used to grab their attention.
    - If the transcriber doesn't pick up what the user said, this can be used to ask the user to repeat themselves. (From the perspective of the assistant, the conversation is idle since it didn't "hear" any user messages.)
    
    @default null (no idle message is spoken)
    """

    idle_message_max_spoken_count: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="idleMessageMaxSpokenCount")
    ] = pydantic.Field(default=None)
    """
    This determines the maximum number of times `idleMessages` can be spoken during the call.
    
    @default 3
    """

    idle_message_reset_count_on_user_speech_enabled: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="idleMessageResetCountOnUserSpeechEnabled")
    ] = pydantic.Field(default=None)
    """
    This determines whether the idle message count is reset whenever the user speaks.
    
    @default false
    """

    idle_timeout_seconds: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="idleTimeoutSeconds")
    ] = pydantic.Field(default=None)
    """
    This is the timeout in seconds before a message from `idleMessages` is spoken. The clock starts when the assistant finishes speaking and remains active until the user speaks.
    
    @default 10
    """

    silence_timeout_message: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="silenceTimeoutMessage")
    ] = pydantic.Field(default=None)
    """
    This is the message that the assistant will say if the call ends due to silence.
    
    If unspecified, it will hang up without saying anything.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
