# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .voicemail_detection_cost_provider import VoicemailDetectionCostProvider
import typing_extensions
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class VoicemailDetectionCost(UncheckedBaseModel):
    type: typing.Literal["voicemail-detection"] = pydantic.Field(default="voicemail-detection")
    """
    This is the type of cost, always 'voicemail-detection' for this class.
    """

    model: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    This is the model that was used to perform the analysis.
    """

    provider: VoicemailDetectionCostProvider = pydantic.Field()
    """
    This is the provider that was used to detect the voicemail.
    """

    prompt_text_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="promptTextTokens")] = pydantic.Field()
    """
    This is the number of prompt text tokens used in the voicemail detection.
    """

    prompt_audio_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="promptAudioTokens")] = pydantic.Field()
    """
    This is the number of prompt audio tokens used in the voicemail detection.
    """

    completion_text_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="completionTextTokens")] = (
        pydantic.Field()
    )
    """
    This is the number of completion text tokens used in the voicemail detection.
    """

    completion_audio_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="completionAudioTokens")] = (
        pydantic.Field()
    )
    """
    This is the number of completion audio tokens used in the voicemail detection.
    """

    cost: float = pydantic.Field()
    """
    This is the cost of the component in USD.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
